%
% This program computes the cdf of the smallest eigenvalue of W_m(n,I_m).
% It is based on an algorithm by Chiani (2013).
%
function y = wisheigmincdf(x,m,n)
m1 = m+(rem(m,2)==1);
alpha = (n-m-1)/2;
gam1 = gamma(alpha+[1:m]);
K = prod(sqrt(pi)*gam1./gamma([1:m]/2)./gamma([n-m+1:n]/2));
y = zeros(size(x));
A = zeros(m1);
for i1=1:numel(x)
    gaminc1 = gammainc(x(i1)/2,alpha+[1:m],'upper');
    gaminc2 = gammainc(x(i1),[n-m+1:n+m-3],'upper').*gamma([n-m+1:n+m-3])./2.^[n-m:n+m-4];
    gam2 = gampdf(x(i1)/2,alpha+[1:m]);
    for i=1:m-1
        for j=i+1:m
            A(i,j) = A(i,j-1)-gaminc1(i)*gam2(j)+gaminc2(i+j-2)/(gam1(i)*gam1(j));
        end
    end
    if m1>m
       A(1:m,m1) = gaminc1(1:m)';
    end
    y(i1) = sqrt(det(A-A'));
end
y = 1-min(1,max(0,K*y));
