%
% This program computes the pdf of the smallest eigenvalue of W_m(n,I_m).
% It is based on an algorithm by Chiani (2013).
%
function y = wisheigminpdf(x,m,n)
if m==1
   y = chi2pdf(x,n);
elseif m==2
   y = exp(-x).*x.^(n-1)/(2*gamma(n))+sqrt(pi)/gamma(n/2)*(n-x-1)/4.* ...
       exp(-x/2).*(x/2).^((n-3)/2).*gammainc(x/2,(n+1)/2,'upper');
elseif n==m+1
   y = m/2*exp(-m*x/2);
else
   m2 = m-(rem(m,2)==1);
   alpha = (n-m-1)/2;
   gam1 = gamma(alpha+[1:m]);
   K = prod(sqrt(pi)*gam1./gamma([1:m]/2)./gamma([n-m+1:n]/2));
   y = zeros(size(x));
   A = zeros(m);
   B = zeros(m2);
   for i1=1:numel(x)
       if x(i1)>0&&x(i1)<Inf
          gaminc1 = gammainc(x(i1)/2,alpha+[1:m],'upper');
          gaminc2 = gammainc(x(i1),[n-m+1:n+m-3],'upper').*gamma([n-m+1:n+m-3])./2.^[n-m:n+m-4];
          gam2 = gampdf(x(i1)/2,alpha+[1:m]);
          for i=1:m-1
              for j=i+1:m
                  A(i,j) = A(i,j-1)-gaminc1(i)*gam2(j)+gaminc2(i+j-2)/(gam1(i)*gam1(j));
              end
          end
          for i=1:m-2
              for j=i+1:m-1
                  B(i,j) = x(i1)^2*A(i,j)-2*x(i1)*((alpha+i)*A(i+1,j)+(alpha+j)*A(i,j+1))+ ...
                           4*(alpha+i)*(alpha+j)*A(i+1,j+1);
              end
          end
          if m2>m-1
             for i=1:m-1
                 B(m2,i) = x(i1)*gaminc1(i)-2*(alpha+i)*gaminc1(i+1);
             end
          end
          y(i1) = exp(-x(i1)/2)*x(i1)^alpha*sqrt(det(B-B'));
       end
   end
   y = max(0,K/2^(alpha+m)/gamma(alpha+m)*y);
end